SystemOrganization addCategory: #'tODE-Search'!

TOView subclass: #TOSearch
	instanceVariableNames: 'classSearch methodSearch searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Search'!

!TOSearch methodsFor: 'searching' stamp: 'dkh 5/30/2011 08:22'!
classSatisfiesQuery: aClass query: query
	| classQueried |
	classQueried := aClass name.
	(classQueried includesSubstring: query caseSensitive: false)
		ifTrue: [ 
			classQueried := classQueried copyFrom: (classQueried indexOfSubCollection: query) + query size to: classQueried size.
			^ true ].
	^ false! !

!TOSearch methodsFor: 'searching' stamp: 'dkh 5/30/2011 09:54'!
doSearch: s main: main
	| searchResults |
	searchResults := OrderedCollection new.
	classSearch
		ifTrue: [ searchResults := searchResults , self classQueryResults ].
	methodSearch
		ifTrue: [ searchResults := searchResults , self methodQueryResults ].
	self pushit: searchResults selecting: #inspect main: main! !

!TOSearch methodsFor: 'initialize-release' stamp: 'dkh 5/29/2011 20:59'!
initialize
	super initialize.
	classSearch := true.
	methodSearch := false! !

!TOSearch methodsFor: 'rendering' stamp: 'dkh 5/30/2011 09:43'!
renderInspectorContentOn: html for: aTOInspector main: main
	| id msId csId |
	aTOInspector getMembers.
	aTOInspector basicInspect
		ifTrue: [ ^ aTOInspector renderStandardContentOn: html main: main ].
	self frame: aTOInspector frame.
	(html textInput)
		id: (id := html nextId);
		exampleText: 'search term';
		value: searchText;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | searchText := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: s main: main.
									main updateCenterSideHistory: s.	"clear the input field"
									s << ((html jQuery id: id) value: '') ]).
	html break.
	(html checkbox)
		id: (csId := html nextId);
		value: classSearch;
		onChange:
				((html jQuery ajax)
						callback: [ :value | classSearch := classSearch not ] value: (html jQuery id: csId) value;
						script: [ :s | s << ((html jQuery id: csId) value: classSearch) ]);
		with: 'Class'.
	html break.
	(html checkbox)
		id: (msId := html nextId);
		value: methodSearch;
		onChange:
				((html jQuery ajax)
						callback: [ :value | methodSearch := methodSearch not ] value: (html jQuery id: msId) value;
						script: [ :s | s << ((html jQuery id: msId) value: methodSearch) ]);
		with: 'Method'.
	html horizontalRule.
	aTOInspector renderBasicToggleOn: html main: main! !

!TOSearch methodsFor: 'accessing' stamp: 'dkh 5/29/2011 17:49'!
tODEInspectorFields
	<tODEInspectorFields>
	"force inspector to have standard and basic views"
	^self tODEBasicInspectorFields! !
